use LWP::Simple;
use NRT::Test;
use NRT::Activity;
use Crypt::JWT(decode_jwt);

package User;

sub new {
  my ($classe, $email, $username, $password, $manager) = @_;
  my $this = {};
  $classe = ref($classe) || $classe;
  bless ( $this, $classe );
  $this->{email} = $email;
  $this->{username} = $username;
  $this->{password} = $password;
  $this->{manager} = $manager;
  $this->{token} = "";
  $this->{id} = "";
  $this->{activities} = [];
  return $this;
}

sub authentification {
  my $this = shift ;
  my $data = "{\"user\" : {\"email\" : \"".$this->{email}."\", \"password\" : \"".$this->{password}."\"}}";
  $rq = $this->{manager}->rq( "tokens", "POST", $data ); ;
  $this->{token} = $rq->{token} ;
  return $rq;
}

sub create {
  my ($this) = shift ;
  my $data = "{\"user\" : {\"username\" : \"". $this->{username} ."\", \"email\" : \"".$this->{email}."\", \"password\" : \"".$this->{password}."\"}}";
  $rq = $this->{manager}->rq( "users", "POST", "$data" );
  $this->{id} = $rq->{data}{id};
  return $rq;
}

sub remove {
  my ($this) = @_ ;
  my $data = "{\"user\" : {\"username\" : \"". $this->{username} ."\", \"email\" : \"".$this->{email}."\", \"password\" : \"".$this->{password}."\"}}";
  my $user_id = Crypt::JWT::decode_jwt(token => $this->get_token, ignore_signature => 1)->{user_id};
  return $this->{manager}->rq( "users/".$user_id, "DELETE", $data, $this->get_token );
}

sub fetch {
  my ($this) = @_ ;
  return $this->{manager}->rq(
    "users/".$this->get_id,
    "GET",
    "",
    $this->get_token );
}

sub get_token {
  my $this = shift;
  if ($this->{token} eq ""){
    $this->authentification;
  }
  return (exists $this->{token})?
    $this->{token} :
    0 ;
}

sub get_id {
  my $this = shift;
  if( !($this->{id} eq "") ){
    return $this->{id};
  }
  $token = $this->get_token;
  if( !$token ){
    return 0;
  }
  return Crypt::JWT::decode_jwt(token => $token, ignore_signature => 1)->{user_id};
}

sub create_activity {
  my ($this, $name) = @_;
  my $activity = Activity->new(
    $name,
    $this);;
  return $activity;
}

return 1;
